<?php if (!defined('PmWiki')) exit();
# Addon 'skinnice' defining interactively skin parameters for PmWiki
# Author Pierre Rouzeau - release 0.6 - 2 may 2007
# License GNU GPL V2
# all files *.skt goes in pub/css directory
# file Main.SkinConfig goes in wikilib.d directory. Can be renamed.
# file skinnice.php go in cookbook directory
# file Main.SkinConfig.php go in local directory. Beware to change
# the password in this file, default 'mypassword'.
# To set background images, you need to activate uploads.
#
# pub/css directory should be writable
# local.css apply to all the wiki. A css file applicable to one group
# should be named 'MyGroup.css' and to a page 'AGroup.OnePage.css'
# file.skc contains data to rebuild the css file
# file.skt contains all or only part of what is in a .skc file but
# can be loaded as a template.
# $EnableSknWhole = 0; block css writing outside local page (for demo)
# $EnableSknSave = 0; block skin config saving (also for demo)
$RecipeInfo['SkinConfig']['Version'] = '2007-05-02';

$HandleActions['skinconf'] = 'Handleskinconf';  
Markup('skinnice', 'directives', '/\\(:skinnice:\\)/e',"Keep(CreSkinForm())");

XLSDV('en',array(
  'SKNwarn' => 'After [Ok] hit browser reload button to see modifications'
 ));
# $SkinCf table content description
# 1rst param: actual value 
# 2nd param: kind of parameter (color:6, font-size:2, etc.)
# 3rd param: text displayed 
# 4rth param: area affected (#wikititle, .pagetitle, etc.)
# 5th param: unit of the parameter (%, em, px, ...)
# 6rst param: default value

//some names are not coherent, they have been conserved for historical compatibility
function InitSkinCf () {
  global $SkinCf;
  $SkinCf ['bgtop']= array (1=>'#e6e6e6',1,'$[Top]','body');
  $SkinCf ['bgtext']= array (1=>'#f6f6f6',1,'$[Text]','#wikibody');
  $SkinCf ['bgleft']= array (1=>'#f0f0f0',1,'$[Sidebar]','#wikileft');
  $SkinCf ['bgleftitle']= array (1=>'#d6d6d6',1,'$[Sidebar title]','#wikileft h1, #wikileft h5, .sidehead');
  $SkinCf ['bglinknorm']= array (1=>'',1,'$[Link]','a');
  $SkinCf ['bglinkvis']= array (1=>'',1,'$[Link: visited]','a:visited');
  $SkinCf ['bglink']= array (1=>'#ffff9f',1,'$[Link: hover]','a:hover'); //bg link hover
  $SkinCf ['bgleftlinknorm']= array (1=>'',1,'$[Sidebar link]','#wikileft a'); //bg left link
  $SkinCf ['bgleftlink']= array (1=>'#ffff9f',1,'$[Sidebar link: hover]','#wikileft a:hover'); ////bg left link hover 
  $SkinCf ['bgleftitlelink']= array (1=>'',1,'$[Sidebar title link]','#wikileft h1 a, #wikileft h5 a, .sidehead a');
  
  $SkinCf ['cltext']= array (1=>'#000000',6,'$[Text]','body');
  $SkinCf ['cltitle']= array (1=>'#303030',6,'$[Title]','#wikititle a');
  $SkinCf ['cllinknorm']= array (1=>'#202020',6,'$[Link]','a'); //cl link
  $SkinCf ['cllinkvis']= array (1=>'#202020',6,'$[Link: visited]','a:visited'); //cl link
  $SkinCf ['cllink']= array (1=>'#202020',6,'$[Link: hover]','a:hover'); //cl link hover
  $SkinCf ['cloption']= array (1=>'#505050',6,'$[Sidebar link]','#wikileft a'); //cl left link
  $SkinCf ['clleftlinkhover']= array (1=>'#505050',6,'$[Sidebar link: hover]','#wikileft a:hover');
  $SkinCf ['clcmdlinkhover']= array (1=>'#505050',6,'$[Commands link]','#wikicmds a, #wikicmds a:link');
  
  $SkinCf ['szmain']= array (1=>'100%',2,'$[Main]','body','%');
  $SkinCf ['sztext']= array (1=>'100%',2,'$[Text]','#wikibody','%');
  $SkinCf ['szleft']= array (1=>'90%',2,'$[Sidebar]','#wikileft','%');
  $SkinCf ['szleftitle']= array (1=>'110%',2,'$[Sidebar title]','#wikileft h1, #wikileft h5, .sidehead','%');  
  $SkinCf ['szcmds']= array (1=>'90%',2,'$[Commands]','#wikicmds','%');
  $SkinCf ['szfoot']= array (1=>'90%',2,'$[Footer]','#wikifoot','%');  
  $SkinCf ['sztitle']= array (1=>'132%',2,'$[Title]','.pagetitle','%');  
  $SkinCf ['szh1']= array (1=>'132%',2,'$[Header 1]','h1','%');
  $SkinCf ['szh2']= array (1=>'124%',2,'$[Header 2]','h2','%');
  $SkinCf ['szh3']= array (1=>'116%',2,'$[Header 3]','h3','%');
  $SkinCf ['szh4']= array (1=>'108%',2,'$[Header 4]','h4','%');
  
  $SkinCf ['fftext']= array (1=>'sans-serif',3,'$[Text]','body, #wikileft, #wikihead');
  $SkinCf ['lhtext']= array (1=>'120%',4,'$[Text]','body','%');
  
  $SkinCf ['bgimgtop']= array (1=>'',5,'$[Top/body]','body');
  $SkinCf ['bgimgleft']= array (1=>'',5,'$[Sidebar]','#wikileft');
  $SkinCf ['bgimgtext']= array (1=>'',5,'$[Text]','#wikibody');
  $SkinCf ['bgimgfoot']= array (1=>'',5,'$[Footer]','#wikifoot');
#  $SkinCf ['sidemrgl']= array (1=>'8px',7,'$[Side margin]','#wikileft','px');  
#  $SkinCf ['sidemrgr']= array (1=>'8px',8,'$[Side margin]','#wikibody','px');  
  $SkinCf ['leftwidth']= array (1=>'8em',9,'$[SideBar width]','#wikileft','em');

  $SkinCf ['tdlink']= array (1=>'underline',10,'$[Link underline]','a'); //bg link hover
  $SkinCf ['tdlinkhover']= array (1=>'underline',10,'$[Link: hover underline]','a:hover'); //bg link hover
  $SkinCf ['tdleftlink']= array (1=>'none',10,'$[Sidebar link underline]','#wikileft a');
  $SkinCf ['tdleftlinkhover']= array (1=>'underline',10,'$[Sidebar link: hover underline]','#wikileft a:hover');
  $SkinCf ['tdcmdlink']= array (1=>'none',10,'$[Commands link underline]','#wikicmds a, #wikicmds a:link');
  $SkinCf ['tdcmdlinkhover']= array (1=>'underline',10,'$[Commands link:hover underline]','#wikicmds a:hover');
    
  $SkinCf ['linkstylelink']= array (1=>'italic',11,'$[Link style: italic]','a');
#  $SkinCf ['linkstylehover']= array (1=>'normal',11,'$[Link hover: italic]','a:hover');
  $SkinCf ['linkstylevisited']= array (1=>'normal',11,'$[Link visited: italic]','a:visited');

  $SkinCf ['leftoptlinebot']= array (1=>'1px solid #999999',12,'$[Underline sidebar option]','#wikileft a');
  $SkinCf ['leftoptlinetop']= array (1=>'2px solid #ffffff',13,'$[Line atop sidebar option]','#wikileft a');
 
  $SkinCf ['hidebotact']= array (1=>'',14,'$[Hide bottom actions]','.footnav');
 
  $SkinCf ['bullet1']= array (1=>'',15,'$[Main level]','#wikibody ul');
  $SkinCf ['bullet2']= array (1=>'',15,'$[Sub-level]','#wikibody ul ul li');
  $SkinCf ['bullet3']= array (1=>'',15,'$[Sub-sub-level]','#wikibody ul ul ul li');
   
//  $SkinCf ['rightwidth']= array (1=>'8em',9,'$[Right width]','#wikiright','em');   
  foreach ($SkinCf as $key=>$dt) $SkinCf[$key][6] = $dt[1]; // create default
}

function readskinconf ($fconf) {
  global $SkinCf;
  clearstatcache();
  if (file_exists ($fconf)) {
    $fp = fopen($fconf, "rb");
    $contents = fread ($fp, filesize ($fconf));
    if (preg_match_all('/([a-z1-9]+):(.*)/', $contents, $match)) {
	  $i = 0;
      foreach($match[1] as $e) {
        $SkinCf[$e][1] = trim($match[2][$i++]);
//		dbs("par:$e, val:".$SkinCf[$e][1]);
	  }	
    }
    fclose($fp);
  }
}
 
function CreSkinForm() {
  global $SkinCf, $ScriptUrl, $FarmD, $pagename, $tfilefmt,
  $GroupPattern,$NamePattern;
  InitSkinCf();
  $pagelist = ListPages();
  $grouplist = array();
  foreach($pagelist as $pname) {
    if (!preg_match("/^($GroupPattern)[\\/.]($NamePattern)$/",$pname,$m))
      continue;
    $grouplist[$m[1]]=$m[1];
  }
  natsort($grouplist);
  $cgroup = @$_REQUEST['apply'];
  $cl = @$_REQUEST['color'];
  $clr = sprintf("%06x",$cl);
  
  $msg = @$_REQUEST['msg'];
  if ($msg!='') {
    if ($msg{0}=='#') $msg = "<span style='color:red;'>$msg</span>";
    $msg = "<h3>$msg</h3>";
  }
  else $msg = '<br/>';
  $sel = ('_'==$cgroup) ? 'selected' : ''; 
  $selgroup = "<select name='apply'>\n<option value=''>\n<option $sel value='_'>$[WHOLE WIKI]\n";
  foreach($grouplist as $g=>$t) {
    $sel = ($g==$cgroup) ? 'selected' : ''; 
    $selgroup .="<option $sel value='$g'>$t";
  }
  $selgroup .= "</select>";
  $cssdir = "$FarmD/pub/css"; 
  $fconf = "$cssdir/local.skc";
  $hlf="<br class='halfv' />";
  readskinconf ($fconf);
  $chkulopleft = ($SkinCf['leftoptlinebot'][1]!='') ? 'checked' : '';
  $chktlopleft = ($SkinCf['leftoptlinetop'][1]!='') ? 'checked' : '';
  $chkhidebotact = ($SkinCf['hidebotact'][1]!='') ? 'checked' : '';
  $Frm = "<form enctype='multipart/form-data' action='$ScriptUrl' method='post'>
  <input type='hidden' name='pagename' value='$pagename' />
  <input type='hidden' name='action' value='skinconf' />
  <input type='hidden' name='sidemrgr' value='{$SkinCf['sidemrgr'][1]}' />   
  <input type='hidden' name='sidemrgl' value='{$SkinCf['sidemrgl'][1]}' />   
  $[Apply to]:\n$selgroup &nbsp; &nbsp;
  <input type='submit' name='ok' value=' $[Save as] ' />  
  <input name='fname' size='12' value='' />$hlf$msg
  <table width = '100%' border='0' cellspacing='0'><tr><td colspan='2'>
  <input type='submit' name='ok' value='    $[Ok]    ' />
  <input type='submit' name='default' value=' $[Default] ' />&nbsp; &nbsp; &nbsp;
  <input type='submit' name='cchart' value='$[Color chart]' />
  <input type='submit' name='cchart2' value='$[Light color]' />
  <span style='background-color:#$clr;' >&nbsp; &nbsp;</span>&nbsp; #$clr
  <br/>$hlf$[SKNwarn]<br />
  </td></tr><tr><td valign='top'>
  <h4>$[Existing styles]</h4>\n".SkOptionDir($cssdir, 'skt', 'tmpl')."
  <h4>$[Font family]</h4>\n".InputSkCf(3)." 
  <h4>$[Font size]</h4>\n".InputSkCf(2)."
  <h4>$[Line height]</h4>\n".InputSkCf(4)."
  <h4>$[Width]</h4>\n".InputSkCf(9)."
  <h4>$[Sidebar links]</h4>\n
  <input type='checkbox' name='leftoptlinebot' value='underline left link' $chkulopleft /> {$SkinCf['leftoptlinebot'][3]}<br />
  <input type='checkbox' name='leftoptlinetop' value='line over left link' $chktlopleft /> {$SkinCf['leftoptlinetop'][3]}
  <h4>$[Bottom actions]</h4>\n
  <input type='checkbox' name='hidebotact' value='hide bottom action' $chkhidebotact /> {$SkinCf['hidebotact'][3]}
  <span style='color: red;'><h1>$[Header 1]</h1><h2>$[Header 2]</h2>
  <h3>$[Header 3]</h3><h4>$[Header 4]</h4></span>
  </td><td valign='top'>$hlf
  <h4>$[Text color]</h4>\n".InputSkCf(6)."
  <h4>$[Background color]</h4>\n".InputSkCf(1)."
  <h4>$[Links underlined]</h4>\n".InputSkCf(10)."
  <h4>$[Links in italic]</h4>\n".InputSkCf(11)."
  <h4>$[Background image]</h4>\n".InputSkCf(5)."
  <h4>$[List bullet]</h4>\n".InputSkCf(15)."
  </td></tr></table></form>";
  $Frm = preg_replace('/\\$\\[(?>([^\\]]+))\\]/e',"XL(PSS('$1'))",$Frm); // Handle translation
  return ($Frm);
}
/* style='display:none' */

function InputSkCf ($type, $width=9) {
	global $SkinCf, $UploadDir, $UploadPrefixFmt, $pagename;
	$SkFontFam = array ('inherit'=>'$[User default]', 'serif'=>'$[Serif]',
		'sans-serif'=>'$[Sans-serif]', 'cursive'=>'$[Cursive]');	
	$SkImgExt = 'jpg|jpeg|gif|png|GIF|PNG|JPG|JPEG';	
	$Frmx = '';
	$chkbox = ($type==10 || $type==11) ? " type='checkbox'" : '';
	if (($type==5) or ($type==15))
		$upldir = FmtPageName("$UploadDir$UploadPrefixFmt", $pagename);
	foreach ($SkinCf as $key=>$dt) {
		if ($dt[2]==$type) {
			$chk = '';
			switch ($type) {
			case 11: //font-style
				if ($dt[1]=='italic') $chk = 'checked';
			case 10: //text-decoration
				if ($dt[1]=='underline') $chk = 'checked';
				$dt[1] = 'x';
			case 1: //bg color
			case 2: //font-size
			case 4: //line-height 
			case 6: //color
			case 9: //width
			case 12: //border-bottom
			case 13: //border-top
				$Frmx .= "<input$chkbox name='$key' size='$width' value='".$dt[1]."' $chk/> &nbsp;".
					$dt[3]." - $[def]: ".$dt[6]."<br />\n";
				break;
			case 3: // font-family
				foreach ($SkFontFam as $fam=>$famtxt) {
					if ($fam==$dt[1]) $chk = 'checked'; else $chk='';
					$Frmx .= "<input type='radio' name='fftext' value='$fam' $chk>$famtxt<br />\n";
				}
				break;
			case 15: // bullet image
#				dbs('Bullet1 : '.$SkinCf['bullet1'][1]);
			case 5: // bg image
				$Frmx .= SkOptionDir($upldir, $SkImgExt, $key, $dt[1])." &nbsp;{$dt[3]}<br />";
				$dir= SkOptionDir($upldir, $SkImgExt, $key, $dt[1]);
				break;
			}
		}
	}
	return $Frmx;
}

function SkOptionDir($dir, $select, $name, $value = '') {
	if ($handle = @opendir($dir)) { 
		$tmpl = "<select name='$name'><option>";
		while (false !== ($file = readdir($handle))) {
			if ($file == $value) $sel= ' selected'; else $sel='';
			if (ereg("((.+)\.($select))$", $file))
				$tmpx[] = "\n<option$sel>$file"; 
		}
		closedir($handle);
		natsort ($tmpx); // error if only one element
		$tmpl .= implode ('', $tmpx); // error if only one element
		$tmpl .= "</select>";
	}
	else $tmpl = "";
	return $tmpl;
}

function Handleskinconf($pagename) {
  global $SkinCf, $FarmD, $UploadUrlFmt, $UploadPrefixFmt, $pagename, $EnableSknSave, $EnableSknWhole;
  $SkCssPar = array(1=>'background-color','font-size','font-family','line-height',
		'background-image','color','padding-left','padding-right','width','text-decoration','font-style','border-bottom','border-top','','list-style-image');		
  InitSkinCf();
  foreach ($SkinCf as $key=>$dt) $SkinCf[$key][1] = ChkData($key);
  $cssdir = "$FarmD/pub/css"; 
  $def = @$_REQUEST['tmpl'];
  if ($def!='') readskinconf ("$cssdir/$def"); // read predefined style file
  if (isset($_POST["default"])) 
    foreach ($SkinCf as $key=>$dt) $SkinCf[$key][1] = $dt[6];
  mkdirp($cssdir);
  fixperms($cssdir); // If already existing
  $fcfname = "$cssdir/local.skc";
  $fp = fopen($fcfname, "wb");  
  foreach ($SkinCf as $key=>$dt) { 
    fwrite($fp,"$key:{$dt[1]}\n");
	$SkArea[] = $dt[4];
  }	
  fclose($fp);
  $name = @$_REQUEST['fname'];
  if (($name!='') && (IsEnabled($EnableSknSave,1))) {
    $name = preg_replace ("/\.skt$/","",$name);
    $fconf = "$cssdir/$name.skt"; 
	if (!copy($fcfname, $fconf))
      $msg = "#$[Creation of file failed]: $name.skt";
	else
	  $msg = "$[Datas saved in file]: $name.skt";
  }	  
  $SkArea = array_unique ($SkArea);
  $uploadurl = FmtPageName("$UploadUrlFmt$UploadPrefixFmt", $pagename);
  $css = '';
  foreach ($SkArea as $area) {
    if ($area!='') {
	  $cssin = '';
      foreach ($SkinCf as $key=>$dt){
	    if (($area==$dt[4]) and ($dt[1]!='') and ($dt[2]!='14')) { #inactive footnav actions hiding
		  $parname = $SkCssPar[$dt[2]]; 
	      $cssin .= $parname;
		  if (($parname=='background-image') or ($parname=='list-style-image'))
		    $cssin .= ":url('$uploadurl/{$dt[1]}');\n";
		  else 
		    $cssin .= ":{$dt[1]};\n";
	    }
	  }
	  if ($cssin != '')
	    $css .= $area." {\n$cssin}\n";
	}
  }
  if ($SkinCf['hidebotact'][1]!='')
    $css .= ".footnav{display:none}";	
  $css .= "
body {margin:0px}
#wikileft .vspace { margin-top:1.125em; }
#wikileft a{
 width:100%;
 display:block; 
}
#wikileft h1, #wikileft h5, .sidehead {
 margin:0px; padding:0px 2px 0px 4px;
}
h3{margin:20px 0px}
h4{margin:16px 0px}
h1, h2, h3, h4, h5, h6 {font-weight: bold ;}
.halfv{line-height:0.5em}
";
  $fpage = "$cssdir/$pagename.css";
  $fp = fopen($fpage, "wb");
  fwrite($fp, $css);
  fclose($fp);
  $cgroup = @$_REQUEST['apply'];
  if (($cgroup != '') && (IsEnabled($EnableSknWhole,1))) {
    if ($cgroup == '_') copy ($fpage, "$cssdir/local.css");
	else copy ($fpage, "$cssdir/$cgroup.css");
  }
  clearstatcache();
  if (isset($_POST["cchart"])) colorchart (24,0);
  if (isset($_POST["cchart2"])) colorchart (8,160);
  sleep(1);
  Redirect($pagename,"\$PageUrl?msg=$msg&apply=$cgroup");
}  

function colorchart ($delta, $limit){
  global $pagename, $PageStartFmt;
  $addr = FmtPageName('$PageUrl',$pagename);
  $PageChartFmt =
"<html><head><style type='text/css'><!--#ilk a{text-decoration:none}--></style></head>
<body><center>".XL(PSS('Click on color to select'))."<br/><br/>
<script language='JavaScript'><!--
for (i=255;i>=$limit;i=i-$delta) { 
document.write('<table id=\"ilk\" border=0 cellpadding=0>');
for (j=255;j>=$limit;j=j-$delta) {
document.write('<tr>');
for (k=255;k>=$limit;k=k-$delta) {
document.write('<td style=\"background-color:rgb('+i+','+j+','+k+');\">');
cl=65536*i+256*j+k;
document.write('<a href=\"$addr?color='+cl+'\">&nbsp; &nbsp; &nbsp; &nbsp;</a></td>'); }
document.write('</tr>'); }
document.write('</table><br>'); }
// end --></script></center></body></html>";
  print ($PageChartFmt);  
  exit;
}

function ChkData ($varname) {
	global $SkinCf;
	$text = @$_REQUEST[$varname];
	$type = $SkinCf[$varname][2];
	if ($type==1) { // color
		$text = strtolower(trim($text));
		if ($text=='none') return $text; // to set empty color
		$valid = ereg ("([0-9a-f]{6})", $text, $regs);
		$text = '#'.$regs[1];
	}
	else if (in_array($type, array(2,4,7,8,9))) { // size - line-height, margin, width (%, %, px, em)
		$unit = @$SkinCf[$varname][5];
		$valid = ereg ("([1-9][0-9]?\.?[0-9]?)", $text, $regs);  
		$text = $regs[1].$unit;
	}
	else if ($type==10) {
		$valid = true;
		$text = $text!='' ? 'underline':'none'; 
	}
	else if ($type==11) {
		$valid = true;
		$text = $text!='' ? 'italic':'normal'; 
	}
	else if ($type==12 || $type==13) {
		$valid = ($text==''); // Only valid if empty, else became default...
	} 
	else return $text;
	if (!$valid) $text = $SkinCf[$varname][6];
	# todo : some treatment to set error in variable and display later on
	return $text;
}

/* debug function */
//function dbs($par, $init=0) {
//	if ($init!=0) 	$fp = fopen('cookbook/errorskn.txt', "w");
//	else 			$fp = fopen('cookbook/errorskn.txt', "a+b");
//	fwrite($fp, "\n".$par);
//	fclose($fp);
//}